export const version = () => '1.0.0';

export class Sensor {
    constructor(id, name, data = {}) {
      if (typeof id != 'string') {
        throw new Error('id n\'est pas du bon type');
      }
      this._id = id;
      if (typeof name != 'string') {
        throw new Error('name n\'est pas du bon type');
      }
      this._name = name;
      this.data = data; 
    }
    get id() {
      return this._id;
    }
    get name() {
      return this._name;
    }
    get data() {
      return this._data;
    }
    set data(dat) {
      if (typeof dat != 'object') {
        throw new Error('la donnée n\'est pas du bon type');
      }
      this._data = dat;
    }
    static toObj(object) {
      return new Sensor(object.id, object.name, object.data);
    }
    toString() {
      let str = `${this.name}@${this.id}`;
      return str;
    }
  }

  export class TimeSeries {
    constructor(values, labels) {
      if (!Array.isArray(values) || !Array.isArray(labels)) {
        throw new Error('TimeSeries accepte que arrays comme parametere');
      }
      this._values = values;
      this._labels = labels;
    }
  
    get values() {
      return this._values;
    }
    get labels() {
      return this._labels;
    }
  }

  export class Datum {
    constructor(value) {
      if (typeof value != 'number') {
        throw new Error('ça doit être un number');
      }
      this._value = value;
    }
    get value() {
      return this._value;
    }
    static toObj(object) {
      return new Datum(object.value);
    }
  }
